# Tests unitaires de l'API ScoDoc

Démarche générale: 

 1. On génère une base SQL de test: voir
   `tools/fakedatabase/create_test_api_database.py`

    
    1. modifier /opt/scodoc/.env pour indiquer 
    ```
    FLASK_ENV=test_api
    FLASK_DEBUG=1 
    ```

    2. En tant qu'utilisateur scodoc, lancer:
    ```
    tools/create_database.sh --drop SCODOC_TEST_API
    flask db upgrade
    flask sco-db-init --erase
    flask init-test-database
    ```

    en plus court: ```
    tools/create_database.sh --drop SCODOC_TEST_API && flask db upgrade &&flask sco-db-init --erase && flask init-test-database
    ```

 2. On lance le serveur ScoDoc sur cette base
    ```
    flask run --host 0.0.0.0
    ```

 3. On lance les tests unitaires API
```
    pytest tests/api/test_api_departements.py
```

Rappel: pour interroger l'API, il fait avoir un utilisateur avec (au moins) la permission
ScoView dans tous les départements. Pour en créer un:
```
 flask user-create lecteur_api LecteurAPI @all
 flask user-password lecteur_api
 flask edit-role LecteurAPI -a ScoView
 flask user-role lecteur_api -a LecteurAPI
```
